#pragma once

#include <vector>
#include <functional>

#include "Core/Core.h"


struct AudioFrame {
    std::vector<uint8> data_;
};


class IAudioRender {
public:
    using LogCallback = std::function<void(int32, const int8*, uint32)>;
    static IAudioRender* Create();

public:
    virtual ~IAudioRender() = default;
    virtual uint64 GetClock() = 0;
    virtual bool Write(const char* data, uint32 size) = 0;
};
