#pragma once

#include "Core/Singleton.h"

#include "VHI/IAudioRender.h"

class VHI : public Singleton<VHI> {
public:
    explicit VHI() noexcept;
    ~VHI() override;

    bool Initialize() override;
    void Uninitialize() override;

    IAudioRender* GetAudioRender() const noexcept {
        return audioRender_.get();
    }

private:
    std::unique_ptr<IAudioRender> audioRender_;
};
