#pragma once

#include <queue>
#include <atomic>
#include <mutex>
#include <condition_variable>

#include "VHI/AudioRenderStd.h"

class WavAudioRender : public AudioRenderStd {
public:
    explicit WavAudioRender() noexcept;
    ~WavAudioRender() override;

    bool Write(const char* data, uint32 size) override;
    uint64 GetClock() override {
        return playedIndex_;
    }

private:
    std::atomic<bool> showExit_{ false };
    std::mutex mutex_;
    std::condition_variable cv_;
    std::queue<std::vector<int8>> audioQueue_;
    std::unique_ptr<std::thread> work_;
    uint64 playedIndex_{ 0 };
};
